{% extends "shuup/front/base.jinja" %}

{% block title %}{% trans %}Discover our stores{% endtrans %}{% endblock %}

{% block breadcrumb %}
    {% call macros.breadcrumb() %}
        {{ macros.render_breadcrumb_item("/", _("Home")) }}
        {{ macros.render_breadcrumb_item(None, _("Discover our stores"), True) }}
    {% endcall %}
{% endblock %}

{% block content %}
    {% placeholder "canvas-stores-top" %}{% endplaceholder %}

    <div class="canvas-stores">
        {% for store in stores %}
            {{ store_information(store) }}
        {% endfor %}
    </div>

    {% placeholder "canvas-stores-bottom" %}{% endplaceholder %}
{% endblock %}

{% macro store_image(store) %}
    {% if store.logo %}
        <div class="canvas-store__image mb-5">
            <div class="canvas-store__logo">
                <img src="{{ store.logo.url }}" alt="">
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro store_map(store) %}
    <div class="canvas-store__map my-5 brands-section__map">
        {% placeholder "vendor_1_map" %}
                 {% plugin "multivendor_vendor_map_filter" %}
                    initial_map_position = "40.6971494,-74.2598655" {# New York City #}
                    default_map_zoom = 10
                    init_map_collapsed = false
                    is_grayscale = true
                    vendor_names_enabled = false
                {% endplugin %}
        {% endplaceholder %}
    </div>
{% endmacro %}

{% macro render_opening_hours(store) %}
    {% if store.opening_periods.all()|length %}
        <div class="canvas-store__opening-hours my-5">
            <button class="custom-accordion__toggle-btn collapsed"
                    type="button"
                    data-toggle="collapse"
                    data-target="#openinghours-accordion-{{ store.id }}"
                    aria-expanded="false"
                    aria-controls="openinghours-accordion-{{ store.id }}">
                <h3>{% trans %}Opening Hours{% endtrans %}</h3>
                <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
                <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
            </button>
            <div class="collapse" id="openinghours-accordion-{{ store.id }}">
                <div class="store-accordion-content">
                    <table>
                        {% for period in store.opening_periods.all() %}
                            <tr>
                                <th class="pb-2 pr-4">{{ period.weekday }}</th>
                                <td class="pb-2">{{ period.start|time }} - {{ period.end|time }}</td>
                            </tr>
                        {% endfor %}
                    </table>
                </div>
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_contact_info(store) %}
    {% if store.contact_address %}
        <div class="canvas-store__contact my-5">
            <button class="custom-accordion__toggle-btn collapsed"
                    type="button"
                    data-toggle="collapse"
                    data-target="#contact-accordion-{{ store.id }}"
                    aria-expanded="false"
                    aria-controls="contact-accordion-{{ store.id }}">
                <h3>{% trans %}Contact Info{% endtrans %}</h3>
                <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
                <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
            </button>
            <div class="collapse" id="contact-accordion-{{ store.id }}">
                <div class="store-accordion-content">
                    {% set address = ", ".join(get_vendor_address_lines(store.contact_address)) %}
                    {% if address %}
                        <p>{{ address }}</p>
                    {% endif %}
                    {% if store.contact_address.phone %}
                        <p>{{ store.contact_address.phone }}</p>
                    {% endif %}
                    {% if store.contact_address.email %}
                        <p>{{ store.contact_address.email }}</p>
                    {% endif %}
                </div>
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_playlist(store) %}
    {% if store.canvas_store.spotify_uri %}
        <div class="canvas-store__playlist my-5">
            <button class="custom-accordion__toggle-btn collapsed"
                    type="button"
                    data-toggle="collapse"
                    data-target="#playlist-accordion-{{ store.id }}"
                    aria-expanded="false"
                    aria-controls="playlist-accordion-{{ store.id }}">
                <h3>{% trans %}Sounds from the Store{% endtrans %}</h3>
                <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
                <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
            </button>
            <div class="collapse" id="playlist-accordion-{{ store.id }}">
                <div class="store-accordion-content">
                    <iframe src="{{ store.canvas_store.spotify_uri }}" width="100%" height="400" frameborder="0" allowtransparency="true" allow="encrypted-media"></iframe>
                </div>
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro render_events(store) %}
    {% if store.canvas_store.store_events.all()|length %}
        <div class="canvas-store__events my-5">
            <button class="custom-accordion__toggle-btn collapsed"
                    type="button"
                    data-toggle="collapse"
                    data-target="#events-accordion-{{ store.id }}"
                    aria-expanded="false"
                    aria-controls="events-accordion-{{ store.id }}">
                <h3>{% trans %}Upcoming Events{% endtrans %}</h3>
                <svg class="icon-plus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M14 23H10L10 1L14 1L14 23Z" fill="currentColor"/>
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
                <svg class="icon-minus" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg">
                    <path d="M1 14L1 10L23 10V14L1 14Z" fill="currentColor"/>
                </svg>
            </button>
            <div class="collapse" id="events-accordion-{{ store.id }}">
                <div class="store-accordion-content">
                    {% for event in store.canvas_store.store_events.all() %}
                        <div class="d-flex align-items-center justify-content-between mb-4 flex-wrap">
                            <div class="lead mr-5 mb-2">{{ event.date }} &ndash; {{ event.location }}</div>
                            <a href="{{ event.eventbrite_url }}" target="_blank" class="btn btn-white btn-lg-horizontal mb-2">
                                {% trans %}Join Event{% endtrans %}
                            </a>
                        </div>
                    {% endfor %}
                </div>
            </div>
        </div>
    {% endif %}
{% endmacro %}

{% macro store_information(store=None) %}
    <div class="canvas-store">
        <div class="canvas-store__row">
            <div class="canvas-store__col">
                <h2 class="canvas-store__name">
                    {{ store.name }}
                </h2>

                {% if store.description %}
                    <div class="canvas-store__description">
                        {{ store.description|linebreaks }}
                    </div>
                {% endif %}
                <div class="hidden-md hidden-lg">
                    {{ store_map(store) }}
                </div>
                {{ render_opening_hours(store) }}
                {{ render_contact_info(store) }}
                {{ render_playlist(store) }}
                {{ render_events(store) }}
            </div>
            <div class="canvas-store__col sidebar-col">
                {{ store_image(store) }}
                <div class="hidden-xs hidden-sm">
                    {{ store_map(store) }}
                </div>
            </div>
        </div>
    </div>
{% endmacro %}
